/*
 * Copyright (c) 2005 Versant Corporation.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * Versant Corporation - initial API and implementation
 */

package org.eclipse.jsr220orm.ui.internal.diagram.er.part;

import org.eclipse.draw2d.AbstractBorder;
import org.eclipse.draw2d.Graphics;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.Label;
import org.eclipse.draw2d.geometry.Insets;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
import org.eclipse.jface.resource.FontRegistry;
import org.eclipse.jsr220orm.ui.internal.diagram.er.figure.TableFigure;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;

public class TableSectionHeaderEditPart extends AbstractGraphicalEditPart {

    public TableSectionHeaderEditPart(Object object) {
        setModel(object);
    }

    protected IFigure createFigure() {
        Label label = new Label(getModel().toString());
        FontRegistry fontRegistry = new FontRegistry();
        Font initialFont = fontRegistry.defaultFont();
        if(initialFont != null){
          FontData[] fontData = initialFont.getFontData();
          for (int i = 0; i < fontData.length; i++) {
              fontData[i].setHeight(fontData[i].getHeight()-1);
          }
          initialFont = new Font(null, fontData);
          label.setFont(initialFont);
        }
        label.setBorder(new TableSectionHeaderBorder());
        Color tc = TableFigure.TOP_COLOR;
        Color bgColor = new Color(null, tc.getRed()-60,tc.getGreen()-60,tc.getBlue()-60);
        label.setForegroundColor(bgColor);
        return label;
    }

    protected void createEditPolicies() {
    }

    private class TableSectionHeaderBorder extends AbstractBorder {

        Insets insets = new Insets(1, 0, 0, 1);

        public Insets getInsets(IFigure figure) {
            return insets;
        }

        /**
         * @see org.eclipse.draw2d.Border#paint(IFigure, Graphics, Insets)
         */
        public void paint(IFigure figure, Graphics graphics, Insets insets) {
            tempRect.setBounds(getPaintRectangle(figure, insets));
            tempRect.height--;
            graphics.setLineWidth(1);
            graphics.drawLine(tempRect.getTopLeft(), tempRect.getTopRight());
            graphics.drawLine(tempRect.getBottomLeft(), tempRect
                    .getBottomRight());
        }
    }
}
